/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.internet.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class PraesentationsexportTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart;
    public de.ivu.elect.business.ergebnis.entity.Praesentationsexportart getPraesentationsexportart(){
      return praesentationsexportart;
    }
    protected final de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeser;
    public de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser getPraesentationsexportausloeser(){
      return praesentationsexportausloeser;
    }
    protected final de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart;
    public de.ivu.elect.business.ergebnis.entity.Stimmabgabeart getStimmabgabeart(){
      return stimmabgabeart;
    }
  protected final de.ivu.elect.business.ergebnis.entity.ErgebnisTK ergebnisTK;
    public de.ivu.elect.business.ergebnis.entity.ErgebnisTK getErgebnisTK(){
      return ergebnisTK;
    }

  public PraesentationsexportTK(
de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart
, de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeser
, de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart
,   de.ivu.elect.business.ergebnis.entity.ErgebnisTK ergebnisTK
  ) {
    super();


      this.praesentationsexportart = praesentationsexportart;
      this.praesentationsexportausloeser = praesentationsexportausloeser;
      this.stimmabgabeart = stimmabgabeart;
        this.ergebnisTK = ergebnisTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((praesentationsexportart == null) ? 0 : praesentationsexportart.hashCode());
                    result = result + ((praesentationsexportausloeser == null) ? 0 : praesentationsexportausloeser.hashCode());
                    result = result + ((stimmabgabeart == null) ? 0 : stimmabgabeart.hashCode());
        
                    result = result + ((ergebnisTK == null) ? 0 : ergebnisTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof PraesentationsexportTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        PraesentationsexportTK other = (PraesentationsexportTK) obj;

                if (praesentationsexportart == null) {
          if (other.praesentationsexportart != null) {
            return false;
          }
        } else if (!praesentationsexportart.equals(other.praesentationsexportart)) {
          return false;
        }
                if (praesentationsexportausloeser == null) {
          if (other.praesentationsexportausloeser != null) {
            return false;
          }
        } else if (!praesentationsexportausloeser.equals(other.praesentationsexportausloeser)) {
          return false;
        }
                if (stimmabgabeart == null) {
          if (other.stimmabgabeart != null) {
            return false;
          }
        } else if (!stimmabgabeart.equals(other.stimmabgabeart)) {
          return false;
        }
        
                if (ergebnisTK == null) {
          if (other.ergebnisTK != null) {
            return false;
          }
        } else if (!ergebnisTK.equals(other.ergebnisTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return PraesentationsexportConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(ergebnisTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(PraesentationsexportConstants.MESSAGE_KEY_ENTITY_EINZAHL, PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL, praesentationsexportart));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(PraesentationsexportConstants.MESSAGE_KEY_ENTITY_EINZAHL, PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL, praesentationsexportausloeser));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(PraesentationsexportConstants.MESSAGE_KEY_ENTITY_EINZAHL, PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL, stimmabgabeart));
        
        return result;
      }


            @Override
            public String toString() {
            return "PraesentationsexportTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"praesentationsexportart="+praesentationsexportart
                            +", praesentationsexportausloeser="+praesentationsexportausloeser
                            +", stimmabgabeart="+stimmabgabeart
                                        +", ergebnisTK="+ergebnisTK
            
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL) + "=" + praesentationsexportart
    + ", " + messages.getMessageForMessageKey(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL) + "=" + praesentationsexportausloeser
    + ", " + messages.getMessageForMessageKey(PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL) + "=" + stimmabgabeart
    + ", " +  toStringLokalisiert(ergebnisTK, messages)
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Praesentationsexport> java.util.Map<PraesentationsexportTK, E> mappePraesentationsexportNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Praesentationsexport::getPraesentationsexportTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Praesentationsexport, PraesentationsexportTK> getPraesentationsexportToTKFunction() {
                return Praesentationsexport::getPraesentationsexportTK;
                }

}
